#include "ComposedObject.h"

ComposedObject::ComposedObject ()
{
	first_component = NULL;
}

ComposedObject::~ComposedObject ()
{
	// do nothing
}

void ComposedObject::AddObject (RawObject * obj)
{
	ComponentElem * current_component;

	if (first_component == NULL)
	{
		first_component = new ComponentElem ();
		first_component->next = NULL;
		first_component->object = obj;
	}
	else
	{
		current_component = first_component;
		while (current_component->next != NULL) current_component = current_component->next;

		current_component->next = new ComponentElem ();
		current_component = current_component->next;
		current_component->next = NULL;
		current_component->object = obj;
	}
}

void ComposedObject::Draw ()
{
	ComponentElem * current_component;

	glColor4fv (color);

	current_component = first_component;
	while (current_component != NULL)
	{
		current_component->object->Draw ();
		current_component = current_component->next;
	}
}