#include "Icosahedron.h"

Icosahedron::Icosahedron (double s)
{
	size = s;
	reciprocal_size = 1 / size;
}

Icosahedron::~Icosahedron ()
{
	// nothing to do
}

void Icosahedron::Draw ()
{
	// manual scaling needed
	glScalef (size, size, size);
	
	glColor4fv (color);
	glutSolidIcosahedron ();

	// undo scaling
	glScalef (reciprocal_size, reciprocal_size, reciprocal_size);
}

double Icosahedron::GetBoundingRadius ()
{
	return size;
}

BoundingBox Icosahedron::GetBoundingBox ()
{
	BoundingBox result;

	result.xmin = -size;
	result.xmax = size;
	result.ymin = -size;
	result.ymax = size;
	result.zmin = -size;
	result.zmax = size;

	return result;
}