#ifndef TEAPOT_
#define TEAPOT_

#include <stdio.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "RawObject.h"

/**
 * \brief A simple teapot.
 *
 * A simple teapot that uses GLUT to draw itself.
 */ 
class Teapot: public RawObject
{
public:
	/**
	 * Constuctor: Brings the object into a consistent state.
	 *
	 * \param size						Size of the teapot
	 */
	Teapot (double size);

	/**
	 * Destuctor.
	 */
	~Teapot ();

	/**
	 * Implementation of the Draw routine. Draws a teapot using GLUT.
	 */
	void Draw ();

	/**
	 * Implementation of the GetBoundingRadius routine.
	 */
	double GetBoundingRadius ();

	/**
	 * Implementation of the GetBoundingBox routine.
	 */
	BoundingBox GetBoundingBox ();

private:
	/** Hide the default constructor. */
	Teapot ();

	/** Size of the teapot. */
	double size;
};


#endif